#!/usr/bin/env python

from collections import defaultdict
import sys

############## BOTTOM-UP MATRIX ############

def backtrack(s,i,j):
    if i == j:
        print "A"+str(i),
    else:
        print "(",
        backtrack(s,i,s[(i,j)])
        backtrack(s,s[(i,j)]+1,j)
        print ")",

def order(p):
    m = defaultdict(lambda: sys.maxint)
    s = defaultdict(lambda: -1)
    n = len(p)
    for i in range(1,n):
        m[(i,i)] = 0
    for l in range(2,n):
        for i in range(1,n-l+1):
            j = i+l-1
            for k in range(i,j):
                r_i = p[i][0]
                c_i = p[k][1]
                c_j = p[j][1]
                q = m[(i,k)] + m[(k+1,j)] + (r_i*c_i*c_j)
                if q < m[(i,j)]:
                    m[(i,j)] = q
                    s[(i,j)] = k
    return (m,s)

if __name__ == "__main__":
    a1 = (30,35)
    a2 = (35,15)
    a3 = (15,5)
    a4 = (5,10)
    a5 = (10,20)
    a6 = (20,25)
    p = [None,a1, a2, a3, a4, a5, a6]
    (m,s) = order(p)
    print "min. number of operations needed :: ", m[(1,len(p)-1)]
    # backtrack(s,1,len(p)-1)